PROGRAM PD602 [ObjectType = 6000; capabilities = ExtendedPNET ; RAMStart = EFF000];

(*$I'PD602v204.SYS'*)

{$MIB MIB_Invisible, MIB_NoBackup}

(*$I'..\inc\PD60XSafetyVars.inc'*)  (* Declaration of 15 "safe" variables *)

{$MIB MIB_Visible, MIB_ReadAccess, MIB_WriteAccess, MIB_Backup}
                                    (* Default backup from here *)
(*$I'..\inc\Pd60XFlash.INC'*)

(*$I'..\inc\pdmodulev204.def'*)     (* Interface declarations *) 
(*$I'..\inc\Globalvar.inc'*)        (* Global variables *)
(*$I'..\inc\GlobalProcedures.inc'*) (* Global procedure, SendSMS *) 
(*$I'When_Error.INC'*)              (* General error handling procedures *)

TASK SendSMSMessage;
BEGIN
  ErrorTextLanguage:= English;      (* Select error text language to be English *)
  GlobalErrorString :='';           (* Clear GlobalErrorString *)
  SendSMS_Flag := False; 

  WHEN ERROR THEN [Disable]         (* Disable Changetask *)
  BEGIN
    WhenErrorRoutine(GlobalErrorString);
    Enable (ChangeTask);
    Return;
  END;
  Disable(Error);	
  Enable(Error, PnetError,PnetReport); 

  Loop
    If SendSMS_Flag Then
    Begin
      SendSMS(Message,PhoneNumber); (* Procdure call, Inserting element in SMSOutputBuffer *)
    End;
    ChangeTask;
  End;
END; 


TASK ReceiveSMSMessages TIMEDINTERRUPT: 1.0;
BEGIN
  ReceivedMessage.PhoneNo := '';    (* Clear PhoneNo *)
  ReceivedMessage.Message := '';    (* Clear SMS Message *)
   
  WHEN ERROR THEN [Disable]         (* Disable Changetask *)
  BEGIN
    WhenErrorRoutine(GlobalErrorString);
    Enable (ChangeTask);
    Return;
  END;
  Disable(Error);
  Enable(Error, PnetError,PnetReport); 

  Loop
    ReceiveSMS();                   (* Procdure call, Reading SMSInputBuffer *)
    ChangeTask;
  End;
END;


TASK PD664_Watchdog TIMEDINTERRUPT: 2.0;
Begin
  WDConfig();
  Loop
    SMSGateway.Service.WDTimer := 30.0; 
    ChangeTask;
  End;
End; 

END.
